'''
Created on 12 sep 2012

@author: tomlun
'''
import math
import pyglet

class FloatText(pyglet.text.Label):
    '''
    classdocs
    '''
    _fade_speed = 200
    _up_speed = 100    

    def __init__(self, text, x, y, batch):
        '''
        Constructor
        '''
        pyglet.text.Label.__init__(self)
        
        self.text = text
        self.x = x
        self.y = y
        self.batch = batch
        self.font_name = "Zombielawn"
        self.font_size = 26
        self.alpha = 255
        self.color = (50, 50, 50, self.alpha)
        self.alive = True
        
    def update(self, dt):
        self.y += self._up_speed * dt
        self.alpha -= self._fade_speed * dt
        
        self.color = (self.color[0],
                      self.color[1],
                      self.color[2],
                      int(math.ceil(self.alpha)))
        
        if self.alpha < 0:
            self.alive = False