'''
Created on 10 sep 2012

@author: tomlun
'''
from lib.sky import Sky
from lib.view import View
import lib
import pyglet

class Menu(View):
    '''
    classdocs
    '''
    w_width = 1024
    w_height = 768    

    def __init__(self, parent):
        '''
        Constructor
        '''
        View.__init__(self, parent)
        self.scene_manager = lib.Root().create_scene_manager("MenuSceneManager")
                
        batch = pyglet.graphics.Batch()
        
        ''' Setup background '''
        self.sky = Sky(self.scene_manager, batch)
        
        logo_texture = pyglet.image.load("data/logo.png")
        logo_node = self.scene_manager.create_scene_node("logo")
        entity = lib.Entity(logo_texture, batch)
        logo_node.attach(entity)
        logo_node.position = ((self.w_width / 2) - (logo_texture.width / 2), 450)
        
        ''' Setup the menu buttons '''
        self.buttons = []
        
        s_btn = lib.ui.Button("START GAME", batch)
        s_btn.x = (self.w_width / 2) - (s_btn.content_width / 2)
        s_btn.y = 350
        s_btn.callback = self.callback_start
        self.buttons.append(s_btn)
               
        e_btn = lib.ui.Button("EXIT", batch)
        e_btn.x = (self.w_width / 2) - (e_btn.content_width / 2)
        e_btn.y = 250
        e_btn.callback = self.callback_exit
        self.buttons.append(e_btn)
    
    def callback_start(self):
        self.parent.set_view("Game")
    
    def callback_exit(self):
        self.parent.stop()  
        
    def update(self, dt):
        self.sky.update(dt)
        
    def on_mouse_release(self, x, y, button, modifiers):
        for btn in [btn for btn in self.buttons if btn.hit_test(x, y)]:
            btn.callback()
            
    def on_mouse_motion(self, x, y, dx, dy): 
        for btn in self.buttons:
            if btn.hit_test(x, y):
                btn.hover()
            else:
                btn.reset_color()