'''
Created on 12 sep 2012

@author: tommy.lundgren
'''
import lib
import pyglet

class Sky(object):
    '''
    classdocs
    '''
    w_width = 1024
    w_height = 768    
    cloud_speed = 70

    def __init__(self, scene_manager, batch):
        '''
        Constructor
        '''
        texture = pyglet.image.load("data/bg.jpg")
        group = pyglet.graphics.OrderedGroup(0)
        
        self.sky_node_1 = scene_manager.create_scene_node("sky_node_1")
        entity = lib.Entity(texture, batch, group)
        self.sky_node_1.attach(entity)
        self.sky_node_1.position = (0, 0)
        
        self.sky_node_2 = scene_manager.create_scene_node("sky_node_2")
        entity = lib.Entity(texture, batch, group)
        self.sky_node_2.attach(entity)
        self.sky_node_2.position = (1024, 0)
        
    def update(self, dt):
        if self.sky_node_1.x <= -self.w_width:
            self.sky_node_1.x = self.sky_node_2.x + self.w_width
            
        if self.sky_node_2.x <= -self.w_width:
            self.sky_node_2.x = self.sky_node_1.x + self.w_width
        
        self.sky_node_1.x -= self.cloud_speed * dt
        self.sky_node_2.x -= self.cloud_speed * dt